<?php
//
//	Module name      :	testasyncjob.php
//
//	Description      :	Test file for asyncjob module
//
//	Parameters       :	When some parameter is found the function TestProcForRun is called
//	Notes - usage    :	None
//


//--- Include files --------------------------------------------------------------------------------



require_once("debug.php");
require_once("asyncjob.php");
require_once("odbc.php");



//--- Global constants -----------------------------------------------------------------------------



define("PAGE_TIMER_NAME", "TestPage");
define("TEST_TIMER_NAME", "TestFunc");



//--- Global variables -----------------------------------------------------------------------------



$Module_prefix = "AJ";



//--- Functions code -------------------------------------------------------------------------------



function PrintFooter()
// Prints the test page footer.
{
	print "
		<!--- Start of PrintFooter ------------------------------------------------------>
		</body>
		</html>";
	$sec = DMtimerRead(PAGE_TIMER_NAME);
	print "
		<!--- End of PrintFooter -------------------------------------------------------->
		<!--- (Elapsed seconds for page construction: $sec) ------------------------->
		";
}



function PrintHeader($browser_title)
// Prints the test page header.
{
	DMtimerReset(PAGE_TIMER_NAME);
	$now = gmdate('D, d M Y H:i:s') . ' GMT';
	header('Expires: ' . $now);						// rfc2616 - Section 14.21
	header('Last-Modified: ' . $now);
	header('Cache-Control: no-store, no-cache, must-revalidate, pre-check=0, post-check=0, max-age=0'); // HTTP/1.1
	header('Pragma: no-cache'); // HTTP/1.0
	print "
		<!--- Start of PrintHeader ------------------------------------------------------>
		<html>
		<head>
			<title>$browser_title</title>
			<meta http-equiv='content-type' content='text/html; charset=iso-8859-1'>
		</head>
		<body>
		<!--- End of PrintHeader -------------------------------------------------------->
		";
}



function Test()
// Calls DPrint for each parameter passed; if ErrorMsg and Result are defined in the tested module,
// calls them and shows their values after the last parameter evaluation. Returns the value of the last
// parameter evaluation.
{
	global $Module_prefix;
	static $first_call = TRUE;

	$em_name = "${Module_prefix}ErrorMsg";
	$em = function_exists($em_name);
	$r_name = "${Module_prefix}Result";
	$r = function_exists($r_name);
	for ($i = 0; $i < func_num_args(); $i++)
		$result = DPrint(func_get_arg($i));
	if ($first_call)
	{
		$first_call = FALSE;
		$msec = 0;
	}
	else
		$msec = DMtimerRead(TEST_TIMER_NAME);
	DMTimerReset(TEST_TIMER_NAME);
	print "
		<table border=1 cellspacing=1 cellpadding=3 width=100%>
		<tr valign=top>
			<td width=1%>
				<center><font style='visibility:hidden'><b>DPrint</b></font></center>
			</td>
			<td><font size=-1>
				" . ($r ? "<b>${Module_prefix}Result:</b> '" . call_user_func($r_name) . "';" : "") . "
				" . ($em ? "<b>${Module_prefix}ErrorMsg:</b> '" . call_user_func($em_name) . "';" : "") . "
				<b>Elapsed secs from last call:</b> $msec</font>
			</td>
		</tr></table><br>
		";
	return $result;
}



function TestProcForRun()
// Job test for AJQueuedRun.
{
	DPrint("TestProcForRun", $_SERVER["argc"], $_SERVER["argv"]);
	return -1;
}



//--- Main code ------------------------------------------------------------------------------------



	if ($_SERVER["argc"] > 1)
		return TestProcForRun();		// On parameters call the procedure to test AJQueuedRun.
	
	DSetDebugWindow(D_WIN_DEF_X, D_WIN_DEF_Y, D_WIN_DEF_WIDTH, D_WIN_DEF_HEIGHT, FALSE);
	PrintHeader("Test file for " . constant("${Module_prefix}_MODULE_NAME"));
	Test("Initial internal status");

	// Test code for asyncjob.php starts here.

	$My_db = array("Dsn" => "statisticheasync", "User" => "apache", "Pwd" => "linuzzo");
	DPrint(ODBCInit($My_db), ODBCExtErrorMsg());

	DPrint("<font size=+1><font color=blue><b>AJDescInsert</b></font></font>");
	$My_job_desc = array(
			"Description"	=> "MyMyJob",
			"ProgPath"		=> "/zio/pino\p.'p'.php",
			"UserId"		=> 100
			);
	Test($j1 = AJDescInsert($My_db, $My_job_desc));
	$My_job_desc = array(
			"Description"	=> "MyTestForRun",
			"ProgPath"		=> "/usr/bin/php /var/www/html/statistiche/inc/testasyncjob.php",
			"UserId"		=> 101
			);
	Test($j2 = AJDescInsert($My_db, $My_job_desc));
	$My_job_desc = array(
			"Description"	=> "MyTestForRun2",
			"ProgPath"		=> "/bin/echo",
			"UserId"		=> 102
			);
	Test($j3 = AJDescInsert($My_db, $My_job_desc));
	Test($j4 = AJDescInsert($My_db, array()));

	DPrint("<font size=+1><font color=blue><b>AJDescRead</b></font></font>");
	Test(AJDescRead($My_db, -20));
	Test(AJDescRead($My_db, $j1));
	Test(AJDescRead($My_db, $j2));
	Test(AJDescRead($My_db, $j3));
	Test(AJDescRead($My_db, $j4));

	DPrint("<font size=+1><font color=blue><b>AJDescModify</b></font></font>");
	Test(AJDescModify($My_db, -20, array()));
	$My_job_desc = array(
			"Description"	=> "MyAndStop",
			"ProgPath"		=> "/pino\zio'ne'.php",
			"UserId"		=> 103
			);
	Test(AJDescModify($My_db, $j1, $My_job_desc));

	DPrint("<font size=+1><font color=blue><b>AJDescReadAll</b></font></font>");
	Test(AJDescReadAll($My_db));

	DPrint("<font size=+1><font color=blue><b>AJDescRemove</b></font></font>");
	Test(AJDescRemove($My_db, -20));
	Test(AJDescRemove($My_db, $j1));
	Test(AJDescReadAll($My_db));

	DPrint("<font size=+1><font color=blue><b>AJPeriodicInsert</b></font></font>");
	Test(AJPeriodicInsert($My_db, array("IdJob" => -20)));
	$My_job_data = array(
			"Period"	=> "1",
			"Disabled"	=> 1,
			"Hidden"	=> 1,
			"IdJob"		=> $j2,
			"Param"		=> "Par",
			"UserId"	=> 100
			);
	Test($p1 = AJPeriodicInsert($My_db, $My_job_data));

	DPrint("<font size=+1><font color=blue><b>AJPeriodicRead</b></font></font>");
	Test(AJPeriodicRead($My_db, -20));
	Test(AJPeriodicRead($My_db, $p1));

	DPrint("<font size=+1><font color=blue><b>AJPeriodicModify</b></font></font>");
	Test(AJPeriodicModify($My_db, -20, $My_job_data));
	$My_job_data = array(
			"Period"	=> "1",
			"Disabled"	=> 1,
			"Hidden"	=> 1,
			"IdJob"		=> -20,
			"Param"		=> "Par",
			"UserId"	=> 101
			);
	Test(AJPeriodicModify($My_db, $p1, $My_job_data));
	$My_job_data = array(
			"Period"	=> "2",
			"Disabled"	=> 0,
			"Hidden"	=> 0,
			"IdJob"		=> $j3,
			"Param"		=> "ParB",
			"UserId"	=> 102
			);
	Test(AJPeriodicModify($My_db, $p1, $My_job_data));

	DPrint("<font size=+1><font color=blue><b>AJPeriodicReadAll</b></font></font>");
	Test(AJPeriodicReadAll($My_db));

	DPrint("<font size=+1><font color=blue><b>AJPeriodicRemove</b></font></font>");
	Test(AJPeriodicRemove($My_db, -20));
	Test(AJPeriodicRemove($My_db, $p1));

	DPrint("<font size=+1><font color=blue><b>AJEnqueue</b></font></font>");
	Test(AJEnqueue($My_db, array()));
	$My_job_data = array(
			"Hidden"	=> 1,
			"IdJob"		=> -20,
			"Param"		=> "Par",
			"UserId"	=> 100
			);
	Test(AJEnqueue($My_db, $My_job_data));
	$My_job_data = array(
			"Hidden"	=> 1,
			"IdJob"		=> $j2,			// $j2 = TestProcForRun function
			"Param"		=> "ParPrima [JobId] [LastQueuedTs] [Period] [PerId] [QueueId] ParDopo",
			"UserId"	=> 101
			);
	Test($q1 = AJEnqueue($My_db, $My_job_data));
	$My_job_data = array(
			"Hidden"	=> 0,
			"IdJob"		=> $j3,			// $j3 = /bin/echo
			"Param"		=> "-e 'ParPrima [JobId] [LastQueuedTs] [Period] [PerId] [QueueId] ParDopo\\nParACapo'",
			"UserId"	=> 102
			);
	Test($q2 = AJEnqueue($My_db, $My_job_data));
	$My_job_data = array(
			"Hidden"	=> 0,
			"IdJob"		=> $j4,			// $j4 = default job
			"Param"		=> "ParIgnorato",
			"UserId"	=> 102
			);
	Test($q2 = AJEnqueue($My_db, $My_job_data));

	DPrint("<font size=+1><font color=blue><b>AJQueuedRead</b></font></font>");
	Test(AJQueuedRead($My_db, -20));
	Test(AJQueuedRead($My_db, $q1));

	DPrint("<font size=+1><font color=blue><b>AJQueuedReadAll</b></font></font>");
	Test(AJQueuedReadAll($My_db));

	DPrint("<font size=+1><font color=blue><b>AJQueuedRun</b></font></font>");
	$AJ_db_log = TRUE;
	DPrint("DbLog module init", DLInit("statistichelog", "log", ""), DLResult(), DLErrorMsg());
	Test(AJQueuedRun($My_db));
	Test(AJQueuedReadAll($My_db));

	DPrint("<font size=+1><font color=blue><b>AJQueuedFlushEnded</b></font></font>");
	Test(AJQueuedFlushEnded($My_db));
	Test(AJQueuedReadAll($My_db));
	Test(AJQueuedFlushEnded($My_db, AJ_NO_TIMEOUT));
	Test(AJQueuedReadAll($My_db));
	Test(AJQueuedFlushEnded($My_db, AJ_NO_TIMEOUT, AJ_NO_TIMEOUT));
	Test(AJQueuedReadAll($My_db));

	DPrint("<font size=+1><font color=blue><b>AJEnqueuePeriodic</b></font></font>");
	$My_job_data = array(
			"Period"	=> "100",
			"Disabled"	=> 0,
			"Hidden"	=> 1,
			"IdJob"		=> $j2,			// $j2 = TestProcForRun function
			"Param"		=> "ParPrima [JobId] [LastQueuedTs] [Period] [PerId] [QueueId] ParDopo",
			"UserId"	=> 100
			);
	Test(AJPeriodicInsert($My_db, $My_job_data));
	$My_job_data = array(
			"Period"	=> "1",
			"Disabled"	=> 0,
			"Hidden"	=> 1,
			"IdJob"		=> $j3,			// $j3 = /bin/echo
			"Param"		=> "ParPrima [JobId] [LastQueuedTs] [Period] [PerId] [QueueId] ParDopo",
			"UserId"	=> 100
			);
	Test(AJPeriodicInsert($My_db, $My_job_data));
	$My_job_data = array(
			"Period"	=> "1",
			"Disabled"	=> 1,
			"Hidden"	=> 1,
			"IdJob"		=> $j3,			// $j3 = /bin/echo
			"Param"		=> "ParamPerProgDisabilitato",
			"UserId"	=> 100
			);
	Test(AJPeriodicInsert($My_db, $My_job_data));
	Test(AJEnqueuePeriodic($My_db));
	Test(AJQueuedReadAll($My_db));
	Test(AJEnqueuePeriodic($My_db));
	Test(AJQueuedReadAll($My_db));
	sleep(2);
	Test(AJEnqueuePeriodic($My_db));
	Test(AJQueuedReadAll($My_db));
	Test(AJPeriodicReadAll($My_db));
	Test(AJQueuedRun($My_db));
	Test(AJQueuedReadAll($My_db));

	// Test code for asyncjob.php ends here.

	Test("Final internal status");
	PrintFooter();	
?>
